Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.om
Interface MutableNodeInfo

All Superinterfaces:
  Item<NodeInfo>, NodeInfo, PullEvent, Source, ValueRepresentation<NodeInfo>

All Known Implementing Classes:
  AbsentExtensionElement, AnnotationParent, DataElement, DocumentImpl, ElementImpl, ExtensionInstruction, LiteralResultElement, NodeImpl, Orphan, SaxonAssign, SaxonCallTemplate, SaxonCollation, SaxonDoctype, SaxonEntityRef, SaxonImportQuery, SaxonParam, SaxonPreprocess, SaxonWhile, SchemaElement, SQLClose, SQLColumn, SQLConnect, SQLDelete, SQLExecute, SQLInsert, SQLQuery, SQLUpdate, StyleElement, UnknownElement, XSDAlternative, XSDAnnotation, XSDAny, XSDAnyAttribute, XSDAssert, XSDAttribute, XSDAttributeGroup, XSDComplexContent, XSDComplexContentRestriction, XSDComplexType, XSDCompositor, XSDDefaultOpenContent, XSDDocumentation, XSDElement, XSDExtension, XSDFacet, XSDFieldOrSelector, XSDGroup, XSDIdentityConstraint, XSDImport, XSDInclude, XSDList, XSDNotation, XSDOpenContent, XSDOverride, XSDRedefine, XSDSchema, XSDSimpleContent, XSDSimpleContentRestriction, XSDSimpleType, XSDSimpleTypeRestriction, XSDUnion, XSLAnalyzeString, XSLApplyImports, XSLApplyTemplates, XSLAttribute, XSLAttributeSet, XSLBreak, XSLBreakOrContinue, XSLCallTemplate, XSLCatch, XSLCharacterMap, XSLChoose, XSLComment, XSLCopy, XSLCopyOf, XSLDecimalFormat, XSLDocument, XSLElement, XSLEvaluate, XSLFallback, XSLForEach, XSLForEachGroup, XSLFork, XSLFunction, XSLGeneralIncorporate, XSLGeneralVariable, XSLIf, XSLImport, XSLImportSchema, XSLInclude, XSLIterate, XSLKey, XSLLeafNodeConstructor, XSLMatchingSubstring, XSLMerge, XSLMergeAction, XSLMergeInput, XSLMergeKey, XSLMergeSource, XSLMessage, XSLMode, XSLNamespace, XSLNamespaceAlias, XSLNextIteration, XSLNextMatch, XSLNumber, XSLOnCompletion, XSLOtherwise, XSLOutput, XSLOutputCharacter, XSLParam, XSLPerformSort, XSLPreserveSpace, XSLProcessingInstruction, XSLResultDocument, XSLSequence, XSLSort, XSLSortOrMergeKey, XSLStylesheet, XSLTemplate, XSLText, XSLTry, XSLValueOf, XSLVariable, XSLVariableDeclaration, XSLWhen, XSLWithParam

    public interface MutableNodeInfo

extends NodeInfo

An extension of the NodeInfo interface defining a node that can be updated. The updating methods are closely modelled on the updating primitives defined in the XQuery Update specification, however, their semantics should not be assumed to be identical to those primitives.

These primitives may leave the tree in a state where the type annotations of nodes do not correctly describe the structure of the nodes. It is the caller's responsibility to maintain the integrity of type annotations.

This interface was introduced in Saxon 9.1 and modified in Saxon 9.2. It is not yet considered 100% stable. Some aspects of the semantics are not clearly specified, for example the effect of each operations on namespace bindings, and such details may change in the future. The primary purpose of this interface is as an internal interface for use by XQuery Update; applications use it (or implement it) at their own risk.

Field Summary

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Method Summary
`void` | `addAttribute(NodeName name, SimpleType attType, CharSequence value, int properties)` Add an attribute to this element node.
`void` | `addNamespace(NamespaceBinding nscode, boolean inherit)` Add a namespace binding (that is, a namespace node) to this element.
`void` | `delete()` Delete this node (that is, detach it from its parent).
`void` | `insertChildren(NodeInfo[] source, boolean atStart, boolean inherit)` Insert a sequence of nodes as children of this node.
`void` | `insertSiblings(NodeInfo[] source, boolean before, boolean inherit)` Insert a sequence of nodes as siblings of this node.
`boolean` | `isDeleted()` Test whether this MutableNodeInfo object represents a node that has been deleted.
`Builder` | `newBuilder()` Get a Builder suitable for building nodes that can be attached to this document.
`void` | `removeAttribute(NodeInfo attribute)` Remove an attribute from this element node
`void` | `removeTypeAnnotation()` Remove type information from this node (and its ancestors, recursively).
`void` | `rename(NodeName newName)` Rename this node.
`void` | `replace(NodeInfo[] replacement, boolean inherit)` Replace this node with a given sequence of nodes.
`void` | `replaceStringValue(CharSequence stringValue)` Replace the string-value of this node.
`void` | `setTypeAnnotation(int typeCode)` Set the type annotation on a node.

Methods inherited from interface net.sf.saxon.om.NodeInfo
`atomize, compareOrder, copy, equals, generateId, getAttributeValue, getAttributeValue, getBaseURI, getColumnNumber, getConfiguration, getDeclaredNamespaces, getDisplayName, getDocumentNumber, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNamePool, getNodeKind, getParent, getPrefix, getRoot, getSchemaType, getStringValue, getSystemId, getTypeAnnotation, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, iterateAxis`

Methods inherited from interface javax.xml.transform.Source
`setSystemId`

Methods inherited from interface net.sf.saxon.om.Item
`getStringValueCS, getTypedValue`

Method Detail

### setTypeAnnotation

    void setTypeAnnotation(int typeCode)

  Set the type annotation on a node. This must only be called when the caller has verified (by validation) that the node is a valid instance of the specified type. The call is ignored if the node is not an element or attribute node.

  Parameters:
    `typeCode` - the type annotation (possibly including high bits set to indicate the isID, isIDREF, and isNilled properties)

### insertChildren

    void insertChildren(NodeInfo[] source,
                        boolean atStart,
                        boolean inherit)

  Insert a sequence of nodes as children of this node.

  This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

  The supplied nodes will form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

  Parameters:
    `source` - the nodes to be inserted. The implementation determines what implementation classes of node it will accept; all implementations must accept nodes constructed using the Builder supplied by the `newBuilder()` method on this object. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, but this depends on the implementation. The argument array may be modified as a result of the call.
    `atStart` - true if the new nodes are to be inserted before existing children; false if they are to be inserted after existing children
    `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
  Throws:
    `IllegalArgumentException` - if the supplied nodes use a node implementation that this implementation does not accept.

### insertSiblings

    void insertSiblings(NodeInfo[] source,
                        boolean before,
                        boolean inherit)

  Insert a sequence of nodes as siblings of this node.

  This method takes no action unless the target node is an element, text node, comment, or processing instruction, and one that has a parent node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

  The supplied nodes will form new children of this node. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

  Parameters:
    `source` - the nodes to be inserted. The implementation determines what implementation classes of node it will accept; all implementations must accept nodes constructed using the Builder supplied by the `newBuilder()` method on this object. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, but this depends on the implementation. The argument array may be modified as a result of the call.
    `before` - true if the new nodes are to be inserted before the target node; false if they are to be inserted after the target node
    `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
  Throws:
    `IllegalArgumentException` - if any supplied node is not a text node, element, comment, or processing instruction or if any of the supplied nodes uses a node implementation that this implementation does not accept.

### removeAttribute

    void removeAttribute(NodeInfo attribute)

  Remove an attribute from this element node

  If the target node is not an element, or if the supplied node is not an attribute of this element, this method takes no action.

  The attribute object itself becomes unusable; any attempt to use this attribute object, or any other object representing the same node, is likely to result in an exception. Calling the `isDeleted()` method on the attribute object will return true.

  Parameters:
    `attribute` - the attribute node to be removed

### addAttribute

    void addAttribute(NodeName name,
                      SimpleType attType,
                      CharSequence value,
                      int properties)

  Add an attribute to this element node.

  If this node is not an element, the method takes no action. If the element already has an attribute with this name, the method throws an exception.

  This method does not perform any namespace fixup. It is the caller's responsibility to ensure that any namespace prefix used in the name of the attribute (or in its value if it has a namespace-sensitive type) is declared on this element.

  Parameters:
    `name` - the name of the new attribute
    `attType` - the type annotation of the new attribute
    `value` - the string value of the new attribute
    `properties` - properties including IS_ID and IS_IDREF properties
  Throws:
    `IllegalStateException` - if the element already has an attribute with the given name.

### delete

    void delete()

  Delete this node (that is, detach it from its parent).

  Following this call, calling `isDeleted()` on the target node or on any of its descendants (or their attributes) will return true, and the node will in all other respects be unusable. The effect of other operations on the node is undefined.

  If the deleted node has preceding and following siblings that are both text nodes, the two text nodes will be joined into a single text node (the identity of this node with respect to the original text nodes is undefined).

### isDeleted

    boolean isDeleted()

  Test whether this MutableNodeInfo object represents a node that has been deleted. Generally, such a node is unusable, and any attempt to use it will result in an exception being thrown.

  Returns:
    true if this node has been deleted

### replace

    void replace(NodeInfo[] replacement,
                 boolean inherit)

  Replace this node with a given sequence of nodes. This node is effectively deleted, and the replacement nodes are attached to the parent of this node in its place.

  The supplied nodes will become children of this node's parent. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

  Parameters:
    `replacement` - the replacement nodes. If this node is an attribute, the replacements must also be attributes; if this node is not an attribute, the replacements must not be attributes. The implementation determines what implementation classes of node it will accept; all implementations must accept nodes constructed using the Builder supplied by the `newBuilder()` method on this object. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, but this depends on the implementation. The argument array may be modified as a result of the call.
    `inherit` - true if the replacement nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
  Throws:
    `IllegalArgumentException` - if any of the replacement nodes is of the wrong kind. When replacing a child node, the replacement nodes must all be elements, text, comment, or PI nodes; when replacing an attribute, the replacement nodes must all be attributes.
    `IllegalStateException` - if this node is deleted or if it has no parent node.
    `IllegalStateException` - if two replacement attributes have the same name.

### replaceStringValue

    void replaceStringValue(CharSequence stringValue)

  Replace the string-value of this node. If applied to an element or document node, this causes all existing children to be deleted, and replaced with a new text node whose string value is the value supplied. The caller is responsible for checking that the value is valid, for example that comments do not contain a double hyphen; the implementation is not required to check for such conditions.

  Parameters:
    `stringValue` - the new string value

### rename

    void rename(NodeName newName)

  Rename this node.

  This call has no effect if applied to a nameless node, such as a text node or comment.

  If necessary, a new namespace binding will be added to the target element, or to the element parent of the target attribute

  Parameters:
    `newName` - the new name for the node
  Throws:
    `IllegalArgumentException` - if the new name code is not present in the name pool, or if it has a (prefix, uri) pair in which the prefix is the same as that of an existing in-scope namespace binding and the uri is different from that namespace binding.

### addNamespace

    void addNamespace(NamespaceBinding nscode,
                      boolean inherit)

  Add a namespace binding (that is, a namespace node) to this element. This call has no effect if applied to a node other than an element.

  Parameters:
    `nscode` - The namespace code representing the (prefix, uri) pair of the namespace binding to be added. If the target element already has a namespace binding with this (prefix, uri) pair, the call has no effect. If the target element currently has a namespace binding with this prefix and a different URI, an exception is raised.
    `inherit` - If true, the new namespace binding will be inherited by any children of the target element that do not already have a namespace binding for the specified prefix, recursively. If false, the new namespace binding will not be inherited.
  Throws:
    `IllegalArgumentException` - if the namespace code is not present in the namepool, or if the target element already has a namespace binding for this prefix

### removeTypeAnnotation

    void removeTypeAnnotation()

  Remove type information from this node (and its ancestors, recursively). This method implements the upd:removeType() primitive defined in the XQuery Update specification. (Note: the caller is responsible for updating the set of nodes marked for revalidation)

### newBuilder

    Builder newBuilder()

  Get a Builder suitable for building nodes that can be attached to this document.

  Returns:
    a new Builder that constructs nodes using the same object model implementation as this one, suitable for attachment to this tree

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.